// ----------------------------------------------------------------------------
//
// frmFishMain(umFishT.PAS/DFM)                           Ulrich Mller 23.1.00
//                                                        Procida 400NT Delphi4
// Testprogramm fr umFish.DLL : Basisfunktionen zum Betrieb der
//                               fischertechnik Interfaces
// Lampen an M1 - M3 werden in einer Schleife an- und ausgeschaltet.
// Ende durch HALT-Button oder Taster E1,
// Unterbrechbarkeit : Application.ProcessMessages
// Zustzlich : Anzeige des Wertes von EX
//
// ----------------------------------------------------------------------------

unit umFishT;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmFishMain = class(TForm)
    cmdStart: TButton;
    cmdHalt: TButton;
    cmdEnde: TButton;
    lblTitel: TLabel;
    lblCopyright: TLabel;
    Label1: TLabel;
    lblAwert: TLabel;
    lblPortName: TLabel;
    Label2: TLabel;
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdHaltClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdStartClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

  var
     frmFishMain: TfrmFishMain;

implementation

{$R *.DFM}

uses umFish;

var
  FishFace: TftiDCB; pFishFace: TpftiDCB;
  Stop: Boolean; PortName: string;

procedure TfrmFishMain.cmdEndeClick(Sender: TObject);
begin
     Self.Close;
end;

procedure TfrmFishMain.cmdHaltClick(Sender: TObject);
begin
  cmdStart.Enabled := true;
  cmdStart.SetFocus;
  cmdEnde.Enabled  := true;
  Stop := true;
end;

procedure TfrmFishMain.FormCreate(Sender: TObject);
begin
     pFishFace := @FishFace;
     Stop := true;
end;

procedure TfrmFishMain.cmdStartClick(Sender: TObject);

var i: Integer;

begin
  PortName := InputBox('umFish.DLL Test',
                       'Portname : COM1-4, LPT1-3, LPT (nur WinNT)', 'COM1');
  lblPortName.Caption := PortName;
// --- FishFace.LPTDelay = 2, wenn mit Extension Module 16554 (COM)
// ---     StartDriver;   //  Windows NT / par.-Interface Start WinRT.SYS
  if OpenInterface(pFishFace, PortName) = ftiFehler then begin
    MessageDlg('InterfaceProblem', mtInformation, [mbOK], 0);
    exit;
    end;
  cmdHalt.SetFocus;
  Stop := false;
  cmdStart.Enabled := false;
  cmdEnde.Enabled  := false;

  i := 1;
  repeat
    SetMotor(pFishFace, i, ftiLinks);
    lblAwert.Caption := format('%d', [GetAnalog(pFishFace, 0)]);
    Application.ProcessMessages;
    Sleep(500);
    SetMotor(pFishFace, i, ftiAus);
    Sleep(300);
    if i>=3 then i := 1 else i := i+1;
  until Stop or (GetInput(pFishFace, 1) = ftiTrue);
  SetMotor(pFishFace, 1, ftiAus);
  cmdEnde.Enabled  := true;
  cmdStart.Enabled := true;
  CloseInterface(pFishFace);
//    StopDriver;               // --- Windows NT Stop WinRT.SYS
end;

end.
